## ros-noetic-floam 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.1)
project(floam)

set(CMAKE_BUILD_TYPE "Release")

# PCL requires C++ 14 and above
set(CMAKE_CXX_FLAGS "-std=c++14")
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -Wall -g")

find_package(catkin REQUIRED COMPONENTS
  geometry_msgs
  nav_msgs
  sensor_msgs
  roscpp
  rospy
  rosbag
  std_msgs
  tf2
  tf2_geometry_msgs
  eigen_conversions
  nodelet
  pcl_ros
)

find_package(Eigen3)
if(NOT EIGEN3_FOUND)
  # Fallback to cmake_modules
  find_package(cmake_modules REQUIRED)
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
  set(EIGEN3_LIBRARIES ${EIGEN_LIBRARIES})  # Not strictly necessary as Eigen is head only
  # Possibly map additional variables to the EIGEN3_ prefix.
else()
  set(EIGEN3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
endif()

find_package(PCL REQUIRED)
find_package(Ceres REQUIRED)

include_directories(
  include
  ${catkin_INCLUDE_DIRS} 
  ${PCL_INCLUDE_DIRS}
  ${CERES_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
)

link_directories(
  include
  ${PCL_LIBRARY_DIRS}
  ${CERES_LIBRARY_DIRS}
)

catkin_package(
  DEPENDS EIGEN3 PCL Ceres 
  INCLUDE_DIRS include
  CATKIN_DEPENDS
  geometry_msgs
  nav_msgs
  roscpp
  rospy
  std_msgs
  nodelet
  tf2
  tf2_geometry_msgs
  eigen_conversions
  rosbag
  sensor_msgs
  pcl_ros
)

# reusable lidar library, provides the Lidar template class
add_library(${PROJECT_NAME}_lidar
  src/lidar.cpp
  src/lidar_utils.cpp
)

add_library(${PROJECT_NAME}_lidar_node
  src/lidar_imager_node.cpp
  src/lidar_scanner_node.cpp
)

target_link_libraries(${PROJECT_NAME}_lidar_node
  ${PROJECT_NAME}_lidar
  ${catkin_LIBRARIES}  
  ${EIGEN3_LIBRARIES}
  ${PCL_LIBRARIES}
  ${CERES_LIBRARIES}
)

add_library(${PROJECT_NAME}_odom
  src/odom_estimation.cpp
  src/lidar_utils.cpp
  src/lidar_optimization.cpp
)

add_library(${PROJECT_NAME}_odom_node
  src/odom_estimation_node.cpp
)

target_link_libraries(${PROJECT_NAME}_odom_node
  ${PROJECT_NAME}_odom
  ${catkin_LIBRARIES}
  ${EIGEN3_LIBRARIES}
  ${PCL_LIBRARIES}
  ${CERES_LIBRARIES}
)

add_library(${PROJECT_NAME}_mapping
  src/lidar_mapping.cpp
)

target_link_libraries(${PROJECT_NAME}_mapping
  ${catkin_LIBRARIES}
  ${EIGEN3_LIBRARIES} 
  ${PCL_LIBRARIES}
  ${CERES_LIBRARIES}
)

add_library(${PROJECT_NAME}_mapping_node
  src/lidar_mapping_node.cpp
)

target_link_libraries(${PROJECT_NAME}_mapping_node
  ${PROJECT_NAME}_mapping
  ${catkin_LIBRARIES}
  ${EIGEN3_LIBRARIES} 
  ${PCL_LIBRARIES}
  ${CERES_LIBRARIES}
)

#############
## Install ##
#############

install(TARGETS
  ${PROJECT_NAME}_lidar
  ${PROJECT_NAME}_lidar_node
  ${PROJECT_NAME}_odom
  ${PROJECT_NAME}_odom_node
  ${PROJECT_NAME}_mapping
  ${PROJECT_NAME}_mapping_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY rviz
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY params
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(FILES
  nodelets.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-floam (0.1.0-1focal) focal; urgency=high

  * increase mapping odom queue size
  * trying to reduce copying
  * improve edge and surface detection
  * trying to improve edge detection
  * rewrote mapping class
  * minor fixes for single-scan device
  * working for unorganized single scanner
  * fix launch files for scanner with 1 scan line
  * functional mapping node
  * functional odom node
  * clean up diff logic, fix edge threshold param name
  * more clean up, default to exact sync in launch
  * fix frame_id, use variable for nearest k
  * use variable for k points to search
  * try different algos for predicting odom
  * clean up odom estimation classes
  * clean up coordinate frames, fix some error prints, transform pointcloud to new frame
  * fix odom node, launch files
  * make edgeThreshold param
  * scanning lidar nodelets functional
  * implement scanning lidar logic too
  * add ros ci actions
  * rewrote mapping nodelet
  * change defaults for lidar launch, add approx sync callback for odom
  * rewrote odom nodelet
  * implemented templates for imager and scanner
  * migrate to templates
  * split lidar class to scanning and imaging
  * edge detection working
  * switch to nodelets
  * fix launch files
  * fix package depends, clean up files
  * fix cmake error
  * add demo link
  * update
  * Merge pull request #24 <https://github.com/flynneva/floam/issues/24> from Chris7462/master
    Fix some minor issues
  * add img
  * update rosbag link
  * update edge cost
  * Fix frame_id names and downSizeFilterSurf and downSizeFilterEdge misplaced
  * remove multiple pointcloud subscription
  * change video
  * add video demo
  * change rosbag location
  * add floam ssl description
  * change frame name
  * add resultion setting and add support for velodyne VLP-16
  * fix function mismatch problem
  * add VLP16 description
  * add new points selection rules and some code optimization
  * add tf
  * add trajectory sever install description
  * change rosbag path
  * change picture location
  * change picture location
  * add mapping gif
  * add mapping node
  * add some comments to code
  * change frame name
  * add license
  * add comments to floam
  * remove opencv dependency
  * add csome instruction to roslaunch
  * add csome instruction to roslaunch
  * add csome instruction to roslaunch
  * update some comparison
  * update some comparison
  * update some comparison
  * update some comparison
  * floam
  * Contributors: Evan Flynn, Wang Han 王晗, chris7462, wh200720041

 -- Evan Flynn <evanflynn.msu@gmail.com>  Sun, 22 Aug 2021 07:00:00 -0000

=== debian/control ===
Source: ros-noetic-floam
Section: misc
Priority: optional
Maintainer: Evan Flynn <evanflynn.msu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libeigen3-dev, libpcl-dev, ros-noetic-catkin, ros-noetic-eigen-conversions, ros-noetic-geometry-msgs, ros-noetic-hector-trajectory-server, ros-noetic-nav-msgs, ros-noetic-nodelet, ros-noetic-pcl-ros, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs
Homepage: https://wanghan.pro
Standards-Version: 3.9.2

Package: ros-noetic-floam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libeigen3-dev, libpcl-dev, ros-noetic-eigen-conversions, ros-noetic-geometry-msgs, ros-noetic-hector-trajectory-server, ros-noetic-nav-msgs, ros-noetic-nodelet, ros-noetic-pcl-ros, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs
Description: A generic Lidar SLAM package based on FLOAM which was based on ALOAM by HKUST and LOAM by CMU

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-floam//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
